package turbowin;


import java.awt.Color;
import java.awt.Cursor;
import java.awt.Desktop;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.nio.charset.Charset;
import java.util.Locale;
import java.util.concurrent.ExecutionException;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.SwingWorker;
import static turbowin.main.detect_OS;

/*
 * about.java
 *
 * Created on 5 november 2008, 9:12
 */



/**
 *
 * @author  Martin
 */
final public class about extends javax.swing.JFrame {

    /** Creates new form about */
    public about() {
        initComponents();
        initComponents2();
        setLocation(main.x_pos_about_frame, main.y_pos_about_frame);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
   // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
   private void initComponents()
   {

      jSeparator1 = new javax.swing.JSeparator();
      jButton1 = new javax.swing.JButton();
      jLabel9 = new javax.swing.JLabel();
      jLabel7 = new javax.swing.JLabel();
      jLabel10 = new javax.swing.JLabel();
      jLabel8 = new javax.swing.JLabel();
      jLabel2 = new javax.swing.JLabel();
      jPanel3 = new javax.swing.JPanel();
      jLabel4 = new javax.swing.JLabel();
      jLabel6 = new javax.swing.JLabel();
      jLabel11 = new javax.swing.JLabel();
      jLabel12 = new javax.swing.JLabel();
      jLabel1 = new javax.swing.JLabel();
      jLabel13 = new javax.swing.JLabel();
      jLabel3 = new javax.swing.JLabel();
      jLabel5 = new javax.swing.JLabel();
      jLabel14 = new javax.swing.JLabel();

      setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
      setTitle("About TurboWin+");
      setMaximumSize(new java.awt.Dimension(600, 700));
      setMinimumSize(new java.awt.Dimension(600, 700));
      setPreferredSize(new java.awt.Dimension(600, 700));
      setResizable(false);

      jButton1.setText("OK");
      jButton1.setMaximumSize(new java.awt.Dimension(75, 25));
      jButton1.setMinimumSize(new java.awt.Dimension(75, 25));
      jButton1.setPreferredSize(new java.awt.Dimension(75, 25));
      jButton1.addActionListener(new java.awt.event.ActionListener()
      {
         public void actionPerformed(java.awt.event.ActionEvent evt)
         {
            OK_button_actionPerformed(evt);
         }
      });

      jLabel9.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);

      jLabel7.setForeground(new java.awt.Color(51, 0, 255));
      jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
      jLabel7.setText("<html><u>TurboWin+ is free software and open-source software (GPLv3)</u></html>");
      jLabel7.addMouseListener(new java.awt.event.MouseAdapter()
      {
         public void mouseClicked(java.awt.event.MouseEvent evt)
         {
            Info_about_GPL_link_mouseClicked(evt);
         }
         public void mouseEntered(java.awt.event.MouseEvent evt)
         {
            Info_about_GPL_link_mouseEntered(evt);
         }
         public void mouseExited(java.awt.event.MouseEvent evt)
         {
            Info_about_GPL_link_mouseExited(evt);
         }
      });

      jLabel8.setForeground(new java.awt.Color(51, 0, 255));
      jLabel8.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
      jLabel8.setText("<html><u>TurboWin+ supports the Voluntary Observing Ship Scheme</u></html>");
      jLabel8.addMouseListener(new java.awt.event.MouseAdapter()
      {
         public void mouseClicked(java.awt.event.MouseEvent evt)
         {
            Info_About_SOT_link_mouseClicked(evt);
         }
         public void mouseEntered(java.awt.event.MouseEvent evt)
         {
            Info_About_SOT_link_mouseEntered(evt);
         }
         public void mouseExited(java.awt.event.MouseEvent evt)
         {
            Info_About_SOT_link_mouseExited(evt);
         }
      });

      jLabel2.setFont(new java.awt.Font("Segoe Print", 1, 10)); // NOI18N
      jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
      jLabel2.setText("Turbo/TurboWin/TurboWin+ since 1990");

      jPanel3.setBackground(new java.awt.Color(235, 235, 235));
      jPanel3.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
      jPanel3.setPreferredSize(new java.awt.Dimension(572, 194));

      jLabel4.setFont(new java.awt.Font("Segoe UI", 1, 12)); // NOI18N
      jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
      jLabel4.setText("jLabel4");

      jLabel6.setBackground(new java.awt.Color(51, 153, 255));
      jLabel6.setFont(new java.awt.Font("Segoe UI", 0, 10)); // NOI18N
      jLabel6.setText("jLabel6");

      jLabel11.setFont(new java.awt.Font("Segoe UI", 0, 10)); // NOI18N
      jLabel11.setText("jLabel11");

      jLabel12.setFont(new java.awt.Font("Segoe UI", 0, 10)); // NOI18N
      jLabel12.setText("jLabel12");

      jLabel1.setFont(new java.awt.Font("Segoe UI", 0, 10)); // NOI18N
      jLabel1.setText("jLabel1");

      jLabel13.setFont(new java.awt.Font("Segoe UI", 0, 10)); // NOI18N
      jLabel13.setText("jLabel13");

      jLabel3.setFont(new java.awt.Font("Segoe UI", 0, 10)); // NOI18N
      jLabel3.setText("jLabel3");

      jLabel5.setFont(new java.awt.Font("Segoe UI", 0, 10)); // NOI18N
      jLabel5.setText("jLabel5");

      jLabel14.setFont(new java.awt.Font("Segoe UI", 0, 10)); // NOI18N
      jLabel14.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
      jLabel14.setText("jLabel14");

      javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
      jPanel3.setLayout(jPanel3Layout);
      jPanel3Layout.setHorizontalGroup(
         jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(jPanel3Layout.createSequentialGroup()
            .addContainerGap()
            .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
               .addComponent(jLabel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
               .addGroup(jPanel3Layout.createSequentialGroup()
                  .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                     .addComponent(jLabel3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                     .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                           .addComponent(jLabel11, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 525, Short.MAX_VALUE)
                           .addComponent(jLabel12, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                           .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                           .addComponent(jLabel13, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 517, javax.swing.GroupLayout.PREFERRED_SIZE))
                     .addComponent(jLabel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                  .addGap(0, 29, Short.MAX_VALUE))
               .addComponent(jLabel14, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addContainerGap())
      );
      jPanel3Layout.setVerticalGroup(
         jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(jPanel3Layout.createSequentialGroup()
            .addContainerGap()
            .addComponent(jLabel4)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(jLabel6)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(jLabel11)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(jLabel12)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(jLabel1)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(jLabel13)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(jLabel3)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(jLabel5)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(jLabel14)
            .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
      );

      javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
      getContentPane().setLayout(layout);
      layout.setHorizontalGroup(
         layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(layout.createSequentialGroup()
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
               .addGroup(layout.createSequentialGroup()
                  .addContainerGap()
                  .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                     .addComponent(jLabel8, javax.swing.GroupLayout.Alignment.TRAILING)
                     .addComponent(jLabel2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                     .addComponent(jLabel7)
                     .addGroup(layout.createSequentialGroup()
                        .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 564, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 66, Short.MAX_VALUE))))
               .addGroup(layout.createSequentialGroup()
                  .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                     .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                     .addGroup(layout.createSequentialGroup()
                        .addGap(253, 253, 253)
                        .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE))
                     .addGroup(layout.createSequentialGroup()
                        .addGap(227, 227, 227)
                        .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, 136, javax.swing.GroupLayout.PREFERRED_SIZE))
                     .addGroup(layout.createSequentialGroup()
                        .addGap(103, 103, 103)
                        .addComponent(jLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, 380, javax.swing.GroupLayout.PREFERRED_SIZE)))
                  .addGap(0, 0, Short.MAX_VALUE)))
            .addContainerGap())
      );
      layout.setVerticalGroup(
         layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
            .addContainerGap()
            .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 53, Short.MAX_VALUE)
            .addComponent(jLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
            .addComponent(jLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(69, 69, 69)
            .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, 68, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(18, 18, 18)
            .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(18, 18, 18)
            .addComponent(jLabel2)
            .addGap(2, 2, 2)
            .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(18, 18, 18)
            .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(15, 15, 15))
      );

      pack();
   }// </editor-fold>//GEN-END:initComponents


   
/***********************************************************************************************/
/*                                                                                             */
/*                                                                                             */
/*                                                                                             */
/***********************************************************************************************/
private void initComponents2()
{
   main.OSType ostype = main.detect_OS();
   String os = "";
   switch (ostype)
   {
      case WINDOWS: os = "WINDOWS"; 
                    break;
      case MACOS:   os = "MACOS"; 
                    break;
      case LINUX:   os = "LINUX"; 
                    break;
      case OTHER:   os = "OTHER"; 
                    break;
      default:      os = "OTHER"; 
                    break;
   }    
   
   
   // NB see also Functions: Themes_1_actionPerformed() etc. [main.java]
   if (main.theme_mode.equals(main.THEME_NIMBUS_NIGHT))          // night mode
   {
      jPanel3.setBackground(new Color(176,176,176));
   }
   else if (main.theme_mode.equals(main.THEME_NIMBUS_SUNRISE))   // sun rise mode
   {
      jPanel3.setBackground(new Color(255,204,153));
   }
   else if (main.theme_mode.equals(main.THEME_NIMBUS_SUNSET))    // sun set mode
   {
      jPanel3.setBackground(new Color(255,204,204));
   }
   else if (main.theme_mode.equals(main.THEME_NIMBUS_SUNSET))    // day mode
   {
      jPanel3.setBackground(new Color(255,255,255));
   }
   
   
   // nb could also be set in design mode but then this will be a fixed char string even if the APPLICATION_NAME was changed
   setTitle("about " + main.APPLICATION_NAME);
   
   // NB this will overwrite default value "Turbo+" (which is in design mode)
   //jLabel1.setText(main.APPLICATION_NAME + " " + main.APPLICATION_VERSION);
   
   if (os.equals("LINUX"))
   { 
      // SOT logo (loading NOT via a background thread)
      loadImage_about_logo_straight(main.ICONS_DIRECTORY + "logo-sot.png");
   
      // GPLv3 logo (loading NOT via a background thread)
      loadImage_GPL_logo_straight(main.ICONS_DIRECTORY + "gplv3-with-text-136x68.png");
   }
   else
   {   
      // SOT logo (loading via a background thread)
      loadImage_about_logo(main.ICONS_DIRECTORY + "logo-sot.png");
   
      // GPLv3 logo (loading via a background thread)
      loadImage_GPL_logo(main.ICONS_DIRECTORY + "gplv3-with-text-136x68.png");
   } // else
   
   jLabel4.setText(main.APPLICATION_NAME + " " + main.APPLICATION_VERSION);

   // NB September 2023: for Windows 11, Microsoft still uses 10.0 as version number (if using System.getProperty("os.version") and "System.getenv("OS_VERSION"") !
   jLabel6.setText("operating system: " + System.getProperty("os.name") + " version " + System.getProperty("os.version") + " running on " + System.getProperty("os.arch"));
   jLabel11.setText("user dir: " + System.getProperty("user.dir"));
   jLabel12.setText("logs dir: " + main.logs_dir);
   
   jLabel1.setText("Java: " + System.getProperty("java.version") + "; " + System.getProperty("java.vm.name"));
   
   // NB See also Function log_memory_statistics() [main_support.java]
   //
   
   // Total designated memory, this will equal the configured -Xmx value:
   long total_designated_memory = Runtime.getRuntime().maxMemory() / 1024 / 1024; // MB
   
   // Current allocated free memory, is the current allocated space ready for new objects. Caution this is not the total free available memory:
   long current_allocated_free_memory = Runtime.getRuntime().freeMemory() /1024 /1024; // MB
   
   // Total allocated memory, is the total allocated space reserved for the java process:
   long total_allocated_memory = Runtime.getRuntime().totalMemory() / 1024 / 1024;
   
   // Used memory, has to be calculated:
   long used_memory = total_allocated_memory - current_allocated_free_memory;
   
   // Total free memory, has to be calculated:
   //long total_free_memory = total_designated_memory - used_memory;
   
   jLabel13.setText("memory: " + "designated " + total_designated_memory + " MB; used " + used_memory + " MB");
   
   jLabel14.setText("Endorsed by the WMO (World Meteorological Organization) for use onboard voluntary observing ships");
   
   // NB System.getProperty("java.runtime version") gives very little added value
   
   jLabel3.setText("default charset: " + Charset.defaultCharset());
   jLabel5.setText("Locale default: " + Locale.getDefault());                            // en_GB: language_COUNTRY
}



/***********************************************************************************************/
/*                                                                                             */
/*                                                                                             */
/*                                                                                             */
/***********************************************************************************************/
private void loadImage_about_logo(final String imagePath) 
{
   new SwingWorker<ImageIcon, Object>() 
   {
      @Override
      public ImageIcon doInBackground() 
      {
         return createImageIcon(imagePath);
      }

      @Override
      public void done()
      {
         try
         {        
            ImageIcon logo_icon = get();
            jLabel9.setIcon(logo_icon); 
         } // try
         catch (InterruptedException ignore) { }
         catch (java.util.concurrent.ExecutionException e) 
         {
            String why;
            Throwable cause = e.getCause();
            if (cause != null) 
            {
               why = cause.getMessage();
            } 
            else 
            {
               why = e.getMessage();
            }
            //System.err.println("Error retrieving file: " + why);
            JOptionPane.showMessageDialog(null, "Error retrieving file: " + why, main.APPLICATION_NAME, JOptionPane.ERROR_MESSAGE);
         } // catch         
      } //  public void done()
   }.execute();
} 



/***********************************************************************************************/
/*                                                                                             */
/*                                                                                             */
/*                                                                                             */
/***********************************************************************************************/
private void loadImage_about_logo_straight(final String imagePath) 
{
   // NB
   //    on Fedora linux approx. every 5-10 times when activating the form the glyphs are not loaded (no errors or exceptions)
   //    even with using BufferdImages instead of the imageIcons, the same result. 
   //    After testing all the pictures were found everytime (so that was not the issue)
   //    It seems the background loading is not always ok on Fedora
   
   ImageIcon logo_icon = createImageIcon(imagePath);
   jLabel9.setIcon(logo_icon); 
} 



/***********************************************************************************************/
/*                                                                                             */
/*                                                                                             */
/*                                                                                             */
/***********************************************************************************************/
private void loadImage_GPL_logo(final String imagePath) 
{
   new SwingWorker<ImageIcon, Object>() 
   {
      @Override
      public ImageIcon doInBackground() 
      {
         return createImageIcon(imagePath);
      }

      @Override
      public void done()
      {
         try
         {        
            ImageIcon logo_icon = get();
            jLabel10.setIcon(logo_icon); 
         } // try
         catch (InterruptedException ignore) { }
         catch (java.util.concurrent.ExecutionException e) 
         {
            String why;
            Throwable cause = e.getCause();
            if (cause != null) 
            {
               why = cause.getMessage();
            } 
            else 
            {
               why = e.getMessage();
            }
            //System.err.println("Error retrieving file: " + why);
            JOptionPane.showMessageDialog(null, "Error retrieving file: " + why, main.APPLICATION_NAME, JOptionPane.ERROR_MESSAGE);
         } // catch         
      } //  public void done()
   }.execute();
} 



/***********************************************************************************************/
/*                                                                                             */
/*                                                                                             */
/*                                                                                             */
/***********************************************************************************************/
private void loadImage_GPL_logo_straight(final String imagePath) 
{
// NB
   //    on Fedora linux approx. every 5-10 times when activating the form the glyphs are not loaded (no errors or exceptions)
   //    even with using BufferdImages instead of the imageIcons, the same result. 
   //    After testing all the pictures were found everytime (so that was not the issue)
   //    It seems the background loading is not always ok on Fedora
   
   ImageIcon logo_icon = createImageIcon(imagePath);
   jLabel10.setIcon(logo_icon); 
         
} 



/***********************************************************************************************/
/*                                                                                             */
/*                                                                                             */
/*                                                                                             */
/***********************************************************************************************/
public ImageIcon createImageIcon(String path_and_file)
{
   URL url = null;

   try
   {
      url = getClass().getResource(path_and_file);
   }
   catch (Exception e) { /* ... */}

   ImageIcon icon_glyph = new javax.swing.ImageIcon(url);

   return icon_glyph;
}



/***********************************************************************************************/
/*                                                                                             */
/*                                                                                             */
/*                                                                                             */
/***********************************************************************************************/
private void OK_button_actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OK_button_actionPerformed
// TODO add your handling code here:
   setVisible(false);
   dispose();
}//GEN-LAST:event_OK_button_actionPerformed



/***********************************************************************************************/
/*                                                                                             */
/*                                                                                             */
/*                                                                                             */
/***********************************************************************************************/
   private void Info_About_SOT_link_mouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Info_About_SOT_link_mouseClicked
      // TODO add your handling code here:
      link_mouse_clicked(LINK_SOT_VOS);
   }//GEN-LAST:event_Info_About_SOT_link_mouseClicked

   
   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/   
   private void Info_About_SOT_link_mouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Info_About_SOT_link_mouseEntered
      // TODO add your handling code here:
      
      link_mouse_entered();
   }//GEN-LAST:event_Info_About_SOT_link_mouseEntered

   
   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/   
   private void Info_About_SOT_link_mouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Info_About_SOT_link_mouseExited
      // TODO add your handling code here:
      
      link_mouse_exited();
   }//GEN-LAST:event_Info_About_SOT_link_mouseExited

   
   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/  
   private void Info_about_GPL_link_mouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Info_about_GPL_link_mouseClicked
      // TODO add your handling code here:
      link_mouse_clicked(LINK_GITLAB);
   }//GEN-LAST:event_Info_about_GPL_link_mouseClicked

   
   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/  
   private void Info_about_GPL_link_mouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Info_about_GPL_link_mouseEntered
      // TODO add your handling code here:
      link_mouse_entered();
   }//GEN-LAST:event_Info_about_GPL_link_mouseEntered

   
   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/  
   private void Info_about_GPL_link_mouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Info_about_GPL_link_mouseExited
      // TODO add your handling code here:
      link_mouse_exited();
   }//GEN-LAST:event_Info_about_GPL_link_mouseExited


   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/  
   private void link_mouse_entered()   
   {
      setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
   }
   
   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/  
   private void link_mouse_exited()   
   {
      setCursor(Cursor.getDefaultCursor());
   }   
   
   
   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/  
   private void link_mouse_clicked(String link_subject)
   {
      
      
      new SwingWorker<Integer, Void>()
      {
         
         @Override
         protected Integer doInBackground() throws Exception
         {
            main.OSType ostype = detect_OS();
            String os = "";
            switch (ostype)
            {
               case WINDOWS: os = "WINDOWS"; 
                             break;
               case MACOS:   os = "MACOS"; 
                             break;
               case LINUX:   os = "LINUX"; 
                             break;
               case OTHER:   os = "OTHER"; 
                             break;
               default:      os = "OTHER"; 
                             break;
            }
            
            
            String link_url = "";
            if (link_subject.equals(LINK_SOT_VOS))
            {
               link_url = "https://www.ocean-ops.org/sot/vos/";
            }
            else if (link_subject.equals(LINK_GITLAB))
            {
               link_url = "https://gitlab.com/KNMI-OSS/turbowin/turbowin"; 
            }
            
            Integer code = 0;                              // ok
            Desktop desktop = null;
            
            if (os.equals("LINUX"))
            {
               // LINUX: first try runtime procedure
               //        second try Desktop procedure
               //
               // why?: on Fedora strange results if first Desktop method was invoked, then the browser only opens as soon as TurboWin+ itself is closed....
               //       (so no error on Desktop procedure/method but strange behavior)
               //       In several correspondance items you can find that the Desktop method is not workig fine on Linux
               //
               // related to: hardware accelarator of the webbrowser? (https://stackoverflow.com/questions/69037458/selenium-chromedriver-gives-initializesandbox-called-with-multiple-threads-in)
               //         because the following errors in output window NetBeans IDE when trying to open URL
               //         libva error: vaGetDriverNameByIndex() failed with unknown libva error, driver_name = (null)
               //         [5757:5757:1122/165659.328325:ERROR:sandbox_linux.cc(376)] InitializeSandbox() called with multiple threads in process gpu-process.  
               //
               try 
               {
                  // create cmd array
                  String[] cmdArray = {"kde-open", link_url};

                  // create a process and execute cmdArray
                  Process process = Runtime.getRuntime().exec(cmdArray);
               } 
               catch (IOException e) 
               {
                  try 
                  {
                     // create cmd array
                     String[] cmdArray = {"xdg-open", link_url};

                     // create a process and execute cmdArray
                     Process process = Runtime.getRuntime().exec(cmdArray);
                  } 
                  catch (IOException e2) 
                  {
                     try 
                     {
                        // create cmd array
                        String[] cmdArray = {"open", link_url};

                        // create a process and execute cmdArray
                        Process process = Runtime.getRuntime().exec(cmdArray);
                     } 
                     catch (IOException e3) 
                     {
                        code = -1;
                     } // catch (IOException e3)                 
                  } // catch (IOException e2)                 
               } // catch  (IOException e) 
               if (code == -1)
               {
                  if (Desktop.isDesktopSupported())
                  {
                     desktop = Desktop.getDesktop();
                     URI uri = null;
                     try
                     {
                        String http_adres = link_url;  
                        uri = new URI(http_adres);
                        desktop.browse(uri);
                     }
                     catch (IOException | URISyntaxException ioe) 
                     { 
                        code = -2;
                     }
                  } // if (Desktop.isDesktopSupported())
                  else
                  {
                     code = -1;
                  } // else
               } // if (code == -1)  
            } // if (os.equals("LINUX"))
            else // Windows etc.
            {
               // Before more Desktop API is used, first check
               // whether the API is supported by this particular
               // virtual machine (VM) on this particular host.
               if (Desktop.isDesktopSupported())
               {
                  desktop = Desktop.getDesktop();
                  URI uri = null;
                  try
                  {
                     String http_adres = link_url;  
                     uri = new URI(http_adres);
                     desktop.browse(uri);
                  }
                  catch (IOException | URISyntaxException ioe) 
                  { 
                     code = -2;
                  }
               } // if (Desktop.isDesktopSupported())
               else
               {
                  code = -1;
               } // else
            } // else (Windows etc.)
            
            
            return code;

         } // protected Integer doInBackground() throws Exception
      
         @Override
         protected void done()
         {
            try
            {
               Integer response_code = get();

               if (response_code == -1)
               {
                  String message = "[GENERAL] Error invoking default web browser";
                  JOptionPane.showMessageDialog(null, message, main.APPLICATION_NAME + " error", JOptionPane.WARNING_MESSAGE);
                  main.log_turbowin_system_message(message);
               }   
               else if (response_code == -2)
               {
                  String message = "[GENERAL] Error invoking URL";
                  JOptionPane.showMessageDialog(null, message, main.APPLICATION_NAME + " error", JOptionPane.WARNING_MESSAGE);
                  main.log_turbowin_system_message(message);
               }   
            } // try
            catch (InterruptedException | ExecutionException ex) 
            {   
               String message = "[GENERAL] Error invoking default web browser; " + ex.toString(); 
               main.log_turbowin_system_message(message);
               //main.jTextField4.setText(main.sdf_tsl_2.format(new Date()) + " UTC " + message);
            } // catch
         } // protected void done()      
      }.execute(); // new SwingWorker<Void, Void>()
   }
   


    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
         @Override
            public void run() {
                new about().setVisible(true);
            }
        });
    }

   // Variables declaration - do not modify//GEN-BEGIN:variables
   private javax.swing.JButton jButton1;
   private javax.swing.JLabel jLabel1;
   private javax.swing.JLabel jLabel10;
   private javax.swing.JLabel jLabel11;
   private javax.swing.JLabel jLabel12;
   private javax.swing.JLabel jLabel13;
   private javax.swing.JLabel jLabel14;
   private javax.swing.JLabel jLabel2;
   private javax.swing.JLabel jLabel3;
   private javax.swing.JLabel jLabel4;
   private javax.swing.JLabel jLabel5;
   private javax.swing.JLabel jLabel6;
   private javax.swing.JLabel jLabel7;
   private javax.swing.JLabel jLabel8;
   private javax.swing.JLabel jLabel9;
   private javax.swing.JPanel jPanel3;
   private javax.swing.JSeparator jSeparator1;
   // End of variables declaration//GEN-END:variables

   
   //private final String LINK_ESURFMAR       =    "link_esurfmar";
   //private final String LINK_GITHUB         =    "link_github";
   //private final String LINK_WEATHER_AT_SEA =    "link_weather_at_sea";
   private final String LINK_GITLAB         =    "link_gitlab";
   private final String LINK_SOT_VOS        =     "link_sot_vos";
}
